#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>

#define BUFSIZE 1024

char *buff;									//размер буфера
int count = BUFSIZE;									//размер считываего блока

char *strerror(int errnum);
int printfile();

int nflg, bflg, uflg, vflg;
int sifi;									//standart input file indicator
int fd;
int newline = 1, spased;
int nlines = 1;

int main(int argc, char *argv[])
{
	int res;								//пихаем в переменную ошибки сист.вызовов
	struct stat st;
	int dev, ino;

	int arg=0;
	while(arg != -1) {
		arg = getopt(argc, argv, "+nvbu");
		switch (arg) {
		case 'n': {
			nflg++;
			break;
		}
		case 'v': {
			vflg++;
			break;
		}
		case 'b': {
			bflg++;
			break;
		}
		case 'u': {
		setbuf(stdout, (char*)NULL);			
		uflg++;
		break;
		}
		case '?': {
		return 1;
		}
		}
	}
	argc -= optind;
	argv = argv + optind;
	//--------------------------------------------------------------------------------------
	res = fstat(fileno(stdout), &st);

	if(res == -1) {
		fprintf(stderr, "1 %s\n", strerror(errno));
		exit(1);
	}	
	dev = st.st_dev;
	ino = st.st_ino;
	if(argc == 0)
		sifi = 1;	
	
	while(argc>0 || sifi) {										//начинаем поочереди открывать перечисленные файлы
		if (argv[0][0] == '-' && argv[0][1] == '\0')
			sifi = 1;
		
		if(sifi)
			fd = fileno (stdin);
		else
			fd = open(*(argv++),O_RDONLY);
		
		if(fd == -1) {
			fprintf(stderr, "1.5 %s\n", strerror(errno));
			exit(1);
		}
		
		res = fstat(fd, &st);
		
		if(res == -1) {
			fprintf(stderr, "2 %s\n", strerror(errno));
			exit(1);
		}
		
		if((!S_ISBLK(st.st_mode)) && (!S_ISREG(st.st_mode)) && (!S_ISCHR(st.st_mode))) {	//проверка на блочное или символьное устройство
			fprintf(stderr, "Its not a regular file, block or char device\n");
			exit(1);
		}
		
		if(S_ISREG(st.st_mode) && st.st_dev == dev && st.st_ino==ino ) {					//тест для исключения ввода вывода в один файл
			fprintf(stderr, "Error! %s is input and output\n", *(argv-1));
			exit(1);
		}
		
		if(S_ISREG(st.st_mode) || S_ISBLK(st.st_mode)) {					//define size of buffer
			count = st.st_blksize;
		}
		
		printfile();
		close(fd);	
		argc--;
	}
	return EXIT_SUCCESS;
}

int printfile()
{
	int res = 1;
	int i;
	unsigned int ch;
	////TMP!!!!!
	buff = malloc(count);
	if(buff == NULL) {
		printf("memory init error:( \n ");
		exit(1);
	}
	for(;;) {
		res = read(fd, buff, count);
		
		if(res == -1 && errno == EINTR)
			continue;
		else if(res == -1) {
			fprintf(stderr, "%s\n", strerror(errno));
			exit(1);
		}
		if(res == 0)
			break;
		
		for(i = 0; i<res; i++) {
			ch = *(buff+i);
			
			if(!bflg && nflg && newline) {
				printf("%5d ", nlines++);
			}
			
			if(bflg && newline) {
				if (ch == '\n') {
					printf("%c", ch);
					continue;
				}
				else 
					printf("%5d ", nlines++);	
			}
			if(ch == '\n')
				newline = 1;
			else
				newline = 0;
			if(ch == '\n' || ch == '\t') {
				printf("%c", ch);
				continue;
			}
			if(vflg) {
				if(ch>127) {
					printf("M-");
					ch &= 127;
				}
				if(ch<' ') {
					printf("^%c",ch+64);
					continue;
				}
				else if (ch == 127) {
					printf("^?");
					continue;
				}
			}
			printf("%c",ch);
		}
	}
	free(buff);
	return 0;
}